## GtkUIManager

GtkUIManager — Constructing menus and toolbars from an XML description

## Functions

GtkUIManager * | gtk_ui_manager_new ()
void | gtk_ui_manager_set_add_tearoffs ()
gboolean | gtk_ui_manager_get_add_tearoffs ()
void | gtk_ui_manager_insert_action_group ()
void | gtk_ui_manager_remove_action_group ()
GList * | gtk_ui_manager_get_action_groups ()
GtkAccelGroup * | gtk_ui_manager_get_accel_group ()
GtkWidget * | gtk_ui_manager_get_widget ()
GSList * | gtk_ui_manager_get_toplevels ()
GtkAction * | gtk_ui_manager_get_action ()
guint | gtk_ui_manager_add_ui_from_string ()
guint | gtk_ui_manager_new_merge_id ()
void | gtk_ui_manager_add_ui ()
void | gtk_ui_manager_remove_ui ()
gchar * | gtk_ui_manager_get_ui ()
void | gtk_ui_manager_ensure_update ()

## Properties

gboolean | add-tearoffs | Read / Write
gchar * | ui | Read

## Signals

void | actions-changed | No Recursion
void | add-widget | No Recursion
void | connect-proxy | No Recursion
void | disconnect-proxy | No Recursion
void | post-activate | No Recursion
void | pre-activate | No Recursion

## Types and Values

struct | GtkUIManager
#define | gtk_ui_manager_add_ui_from_file
enum | GtkUIManagerItemType

## Object Hierarchy

        GObject
        ╰── GtkUIManager

## Implemented Interfaces

GtkUIManager implements GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

A GtkUIManager constructs a user interface (menus and toolbars) from one or more UI definitions, which reference actions from one or more action groups.

### UI Definitions

The UI definitions are specified in an XML format which can be roughly described by the following DTD.

Do not confuse the GtkUIManager UI Definitions described here with the similarly named GtkBuilder UI Definitions.

    <!ELEMENT ui          (menubar|toolbar|popup|accelerator)* >
    <!ELEMENT menubar     (menuitem|separator|placeholder|menu)* >
    <!ELEMENT menu        (menuitem|separator|placeholder|menu)* >
    <!ELEMENT popup       (menuitem|separator|placeholder|menu)* >
    <!ELEMENT toolbar     (toolitem|separator|placeholder)* >
    <!ELEMENT placeholder (menuitem|toolitem|separator|placeholder|menu)* >
    <!ELEMENT menuitem     EMPTY >
    <!ELEMENT toolitem     (menu?) >
    <!ELEMENT separator    EMPTY >
    <!ELEMENT accelerator  EMPTY >
    <!ATTLIST menubar      name                      #IMPLIED
                           action                    #IMPLIED >
    <!ATTLIST toolbar      name                      #IMPLIED
                           action                    #IMPLIED >
    <!ATTLIST popup        name                      #IMPLIED
                           action                    #IMPLIED
                           accelerators (true|false) #IMPLIED >
    <!ATTLIST placeholder  name                      #IMPLIED
                           action                    #IMPLIED >
    <!ATTLIST separator    name                      #IMPLIED
                           action                    #IMPLIED
                           expand       (true|false) #IMPLIED >
    <!ATTLIST menu         name                      #IMPLIED
                           action                    #REQUIRED
                           position     (top|bot)    #IMPLIED >
    <!ATTLIST menuitem     name                      #IMPLIED
                           action                    #REQUIRED
                           position     (top|bot)    #IMPLIED
                           always-show-image (true|false) #IMPLIED >
    <!ATTLIST toolitem     name                      #IMPLIED
                           action                    #REQUIRED
                           position     (top|bot)    #IMPLIED >
    <!ATTLIST accelerator  name                      #IMPLIED
                           action                    #REQUIRED >

There are some additional restrictions beyond those specified in the DTD, e.g. every toolitem must have a toolbar in its anchestry and every menuitem must have a menubar or popup in its anchestry. Since a GMarkup parser is used to parse the UI description, it must not only be valid XML, but valid GMarkup.

If a name is not specified, it defaults to the action. If an action is not specified either, the element name is used. The name and action attributes must not contain '/' characters after parsing (since that would mess up path lookup) and must be usable as XML attributes when enclosed in doublequotes, thus they must not '"' characters or references to the &quot; entity.

Example 30. A UI definition

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24

    <ui>
      <menubar>
        <menu name="FileMenu" action="FileMenuAction">
          <menuitem name="New" action="New2Action" />
          <placeholder name="FileMenuAdditions" />
        </menu>
        <menu name="JustifyMenu" action="JustifyMenuAction">
          <menuitem name="Left" action="justify-left"/>
          <menuitem name="Centre" action="justify-center"/>
          <menuitem name="Right" action="justify-right"/>
          <menuitem name="Fill" action="justify-fill"/>
        </menu>
      </menubar>
      <toolbar action="toolbar1">
        <placeholder name="JustifyToolItems">
          <separator/>
          <toolitem name="Left" action="justify-left"/>
          <toolitem name="Centre" action="justify-center"/>
          <toolitem name="Right" action="justify-right"/>
          <toolitem name="Fill" action="justify-fill"/>
          <separator/>
        </placeholder>
      </toolbar>
    </ui>

The constructed widget hierarchy is very similar to the element tree of the XML, with the exception that placeholders are merged into their parents. The correspondence of XML elements to widgets should be almost obvious:

menubar | a GtkMenuBar
toolbar | a GtkToolbar
popup | a toplevel GtkMenu
menu | a GtkMenu attached to a menuitem
menuitem | a GtkMenuItem subclass, the exact type depends on the action
toolitem | a GtkToolItem subclass, the exact type depends on the action. Note that toolitem elements may contain a menu element, but only if their associated action specifies a GtkMenuToolButton as proxy.
separator | a GtkSeparatorMenuItem or GtkSeparatorToolItem
accelerator | a keyboard accelerator

The "position" attribute determines where a constructed widget is positioned wrt. to its siblings in the partially constructed tree. If it is "top", the widget is prepended, otherwise it is appended.

### UI Merging

The most remarkable feature of GtkUIManager is that it can overlay a set of menuitems and toolitems over another one, and demerge them later.

Merging is done based on the names of the XML elements. Each element is identified by a path which consists of the names of its anchestors, separated by slashes. For example, the menuitem named "Left" in the example above has the path `/ui/menubar/JustifyMenu/Left` and the toolitem with the same name has path `/ui/toolbar1/JustifyToolItems/Left`.

### Accelerators

Every action has an accelerator path. Accelerators are installed together with menuitem proxies, but they can also be explicitly added with <accelerator> elements in the UI definition. This makes it possible to have accelerators for actions even if they have no visible proxies.

### Smart Separators

The separators created by GtkUIManager are "smart", i.e. they do not show up in the UI unless they end up between two visible menu or tool items. Separators which are located at the very beginning or end of the menu or toolbar containing them, or multiple separators next to each other, are hidden. This is a useful feature, since the merging of UI elements from multiple sources can make it hard or impossible to determine in advance whether a separator will end up in such an unfortunate position.

For separators in toolbars, you can set `expand="true"` to turn them from a small, visible separator to an expanding, invisible one. Toolitems following an expanding separator are effectively right-aligned.

### Empty Menus

Submenus pose similar problems to separators inconnection with merging. It is impossible to know in advance whether they will end up empty after merging. GtkUIManager offers two ways to treat empty submenus:

- make them disappear by hiding the menu item they're attached to

- add an insensitive "Empty" item

The behaviour is chosen based on the "hide_if_empty" property of the action to which the submenu is associated.

### GtkUIManager as GtkBuildable

The GtkUIManager implementation of the GtkBuildable interface accepts GtkActionGroup objects as <child> elements in UI definitions.

A GtkUIManager UI definition as described above can be embedded in an GtkUIManager <object> element in a GtkBuilder UI definition.

The widgets that are constructed by a GtkUIManager can be embedded in other parts of the constructed user interface with the help of the "constructor" attribute. See the example below.

Example 31. An embedded GtkUIManager UI definition

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22

    <object class="GtkUIManager" id="uiman">
      <child>
        <object class="GtkActionGroup" id="actiongroup">
          <child>
            <object class="GtkAction" id="file">
              <property name="label">_File</property>
            </object>
          </child>
        </object>
      </child>
      <ui>
        <menubar name="menubar1">
          <menu action="file">
          </menu>
        </menubar>
      </ui>
    </object>
    <object class="GtkWindow" id="main-window">
      <child>
        <object class="GtkMenuBar" id="menubar1" constructor="uiman"/>
      </child>
    </object>

## Functions

### gtk_ui_manager_new ()

    GtkUIManager *
    gtk_ui_manager_new (void);

Creates a new ui manager object.

#### Returns

a new ui manager object.

Since: 2.4

### gtk_ui_manager_set_add_tearoffs ()

    void
    gtk_ui_manager_set_add_tearoffs (GtkUIManager *self,
                                     gboolean add_tearoffs);

Sets the "add_tearoffs" property, which controls whether menus generated by this GtkUIManager will have tearoff menu items.

Note that this only affects regular menus. Generated popup menus never have tearoff menu items.

#### Parameters

self | a GtkUIManager |
add_tearoffs | whether tearoff menu items are added |

Since: 2.4

### gtk_ui_manager_get_add_tearoffs ()

    gboolean
    gtk_ui_manager_get_add_tearoffs (GtkUIManager *self);

Returns whether menus generated by this GtkUIManager will have tearoff menu items.

#### Parameters

self | a GtkUIManager |

#### Returns

whether tearoff menu items are added

Since: 2.4

### gtk_ui_manager_insert_action_group ()

    void
    gtk_ui_manager_insert_action_group (GtkUIManager *self,
                                        GtkActionGroup *action_group,
                                        gint pos);

Inserts an action group into the list of action groups associated with `self` . Actions in earlier groups hide actions with the same name in later groups.

#### Parameters

self | a GtkUIManager object |
action_group | the action group to be inserted |
pos | the position at which the group will be inserted. |

Since: 2.4

### gtk_ui_manager_remove_action_group ()

    void
    gtk_ui_manager_remove_action_group (GtkUIManager *self,
                                        GtkActionGroup *action_group);

Removes an action group from the list of action groups associated with `self` .

#### Parameters

self | a GtkUIManager object |
action_group | the action group to be removed |

Since: 2.4

### gtk_ui_manager_get_action_groups ()

    GList *
    gtk_ui_manager_get_action_groups (GtkUIManager *self);

Returns the list of action groups associated with `self` .

#### Parameters

self | a GtkUIManager object |

#### Returns

a GList of action groups. The list is owned by GTK+ and should not be modified.

[element-type GtkActionGroup][transfer none]

Since: 2.4

### gtk_ui_manager_get_accel_group ()

    GtkAccelGroup *
    gtk_ui_manager_get_accel_group (GtkUIManager *self);

Returns the GtkAccelGroup associated with `self` .

#### Parameters

self | a GtkUIManager object |

#### Returns

the GtkAccelGroup.

[transfer none]

Since: 2.4

### gtk_ui_manager_get_widget ()

    GtkWidget *
    gtk_ui_manager_get_widget (GtkUIManager *self,
                               const gchar *path);

Looks up a widget by following a path. The path consists of the names specified in the XML description of the UI. separated by '/'. Elements which don't have a name or action attribute in the XML (e.g. <popup>) can be addressed by their XML element name (e.g. "popup"). The root element ("/ui") can be omitted in the path.

Note that the widget found by following a path that ends in a <menu> element is the menuitem to which the menu is attached, not the menu itself.

Also note that the widgets constructed by a ui manager are not tied to the lifecycle of the ui manager. If you add the widgets returned by this function to some container or explicitly ref them, they will survive the destruction of the ui manager.

#### Parameters

self | a GtkUIManager |
path | a path |

#### Returns

the widget found by following the path, or `NULL` if no widget was found.

[transfer none]

Since: 2.4

### gtk_ui_manager_get_toplevels ()

    GSList *
    gtk_ui_manager_get_toplevels (GtkUIManager *self,
                                  GtkUIManagerItemType types);

Obtains a list of all toplevel widgets of the requested types.

#### Parameters

self | a GtkUIManager |
types | specifies the types of toplevel widgets to include. Allowed types are GTK_UI_MANAGER_MENUBAR, GTK_UI_MANAGER_TOOLBAR and GTK_UI_MANAGER_POPUP. |

#### Returns

a newly-allocated GSList of all toplevel widgets of the requested types. Free the returned list with `g_slist_free()`.

[element-type GtkWidget][transfer container]

Since: 2.4

### gtk_ui_manager_get_action ()

    GtkAction *
    gtk_ui_manager_get_action (GtkUIManager *self,
                               const gchar *path);

Looks up an action by following a path. See `gtk_ui_manager_get_widget()` for more information about paths.

#### Parameters

self | a GtkUIManager |
path | a path |

#### Returns

the action whose proxy widget is found by following the path, or `NULL` if no widget was found.

[transfer none]

Since: 2.4

### gtk_ui_manager_add_ui_from_string ()

    guint
    gtk_ui_manager_add_ui_from_string (GtkUIManager *self,
                                       const gchar *buffer,
                                       gssize length,
                                       GError **error);

Parses a string containing a UI definition and merges it with the current contents of `self` . An enclosing <ui> element is added if it is missing.

#### Parameters

self | a GtkUIManager object |
buffer | the string to parse |
length | the length of `buffer` (may be -1 if `buffer` is nul-terminated) |
error | return location for an error |

#### Returns

The merge id for the merged UI. The merge id can be used to unmerge the UI with `gtk_ui_manager_remove_ui()`. If an error occurred, the return value is 0.

Since: 2.4

### gtk_ui_manager_new_merge_id ()

    guint
    gtk_ui_manager_new_merge_id (GtkUIManager *self);

Returns an unused merge id, suitable for use with `gtk_ui_manager_add_ui()`.

#### Parameters

self | a GtkUIManager |

#### Returns

an unused merge id.

Since: 2.4

### gtk_ui_manager_add_ui ()

    void
    gtk_ui_manager_add_ui (GtkUIManager *self,
                           guint merge_id,
                           const gchar *path,
                           const gchar *name,
                           const gchar *action,
                           GtkUIManagerItemType type,
                           gboolean top);

Adds a UI element to the current contents of `self` .

If `type` is `GTK_UI_MANAGER_AUTO`, GTK+ inserts a menuitem, toolitem or separator if such an element can be inserted at the place determined by `path` . Otherwise `type` must indicate an element that can be inserted at the place determined by `path` .

If `path` points to a menuitem or toolitem, the new element will be inserted before or after this item, depending on `top` .

#### Parameters

self | a GtkUIManager |
merge_id | the merge id for the merged UI, see `gtk_ui_manager_new_merge_id()` |
path | a path |
name | the name for the added UI element |
action | the name of the action to be proxied, or `NULL` to add a separator. | [allow-none]
type | the type of UI element to add. |
top | if `TRUE`, the UI element is added before its siblings, otherwise it is added after its siblings. |

Since: 2.4

### gtk_ui_manager_remove_ui ()

    void
    gtk_ui_manager_remove_ui (GtkUIManager *self,
                              guint merge_id);

Unmerges the part of `self` s content identified by `merge_id` .

#### Parameters

self | a GtkUIManager object |
merge_id | a merge id as returned by `gtk_ui_manager_add_ui_from_string()` |

Since: 2.4

### gtk_ui_manager_get_ui ()

    gchar *
    gtk_ui_manager_get_ui (GtkUIManager *self);

Creates a UI definition of the merged UI.

#### Parameters

self | a GtkUIManager |

#### Returns

A newly allocated string containing an XML representation of the merged UI.

Since: 2.4

### gtk_ui_manager_ensure_update ()

    void
    gtk_ui_manager_ensure_update (GtkUIManager *self);

Makes sure that all pending updates to the UI have been completed.

This may occasionally be necessary, since GtkUIManager updates the UI in an idle function. A typical example where this function is useful is to enforce that the menubar and toolbar have been added to the main window before showing it:

    1
    2
    3
    4
    5
    6
    7

    gtk_container_add (GTK_CONTAINER (window), vbox);
    g_signal_connect (merge, "add-widget",
                      G_CALLBACK (add_widget), vbox);
    gtk_ui_manager_add_ui_from_file (merge, "my-menus");
    gtk_ui_manager_add_ui_from_file (merge, "my-toolbars");
    gtk_ui_manager_ensure_update (merge);
    gtk_widget_show (window);

#### Parameters

self | a GtkUIManager |

Since: 2.4

## Types and Values

### struct GtkUIManager

    struct GtkUIManager;

The GtkUIManager struct contains only private members and should not be accessed directly.

### gtk_ui_manager_add_ui_from_file

    #define gtk_ui_manager_add_ui_from_file gtk_ui_manager_add_ui_from_file_utf8

Parses a file containing a UI definition and merges it with the current contents of `self` .

#### Returns

The merge id for the merged UI. The merge id can be used to unmerge the UI with `gtk_ui_manager_remove_ui()`. If an error occurred, the return value is 0.

Since: 2.4

### enum GtkUIManagerItemType

These enumeration values are used by `gtk_ui_manager_add_ui()` to determine what UI element to create.

#### Members

GTK_UI_MANAGER_AUTO | Pick the type of the UI element according to context. |
GTK_UI_MANAGER_MENUBAR | Create a menubar. |
GTK_UI_MANAGER_MENU | Create a menu. |
GTK_UI_MANAGER_TOOLBAR | Create a toolbar. |
GTK_UI_MANAGER_PLACEHOLDER | Insert a placeholder. |
GTK_UI_MANAGER_POPUP | Create a popup menu. |
GTK_UI_MANAGER_MENUITEM | Create a menuitem. |
GTK_UI_MANAGER_TOOLITEM | Create a toolitem. |
GTK_UI_MANAGER_SEPARATOR | Create a separator. |
GTK_UI_MANAGER_ACCELERATOR | Install an accelerator. |
GTK_UI_MANAGER_POPUP_WITH_ACCELS | Same as `GTK_UI_MANAGER_POPUP`, but the actions' accelerators are shown. |

## Property Details

### The `“add-tearoffs”` property

      “add-tearoffs”             gboolean

The "add-tearoffs" property controls whether generated menus have tearoff menu items.

Note that this only affects regular menus. Generated popup menus never have tearoff menu items.

Flags: Read / Write

Default value: FALSE

Since: 2.4

### The `“ui”` property

      “ui”                       gchar *

An XML string describing the merged UI.

Flags: Read

Default value: "<ui>\n</ui>\n"

## Signal Details

### The `“actions-changed”` signal

    void
    user_function (GtkUIManager *merge,
                   gpointer      user_data)

The "actions-changed" signal is emitted whenever the set of actions changes.

#### Parameters

merge | a GtkUIManager |
user_data | user data set when the signal handler was connected. |

Flags: No Recursion

Since: 2.4

### The `“add-widget”` signal

    void
    user_function (GtkUIManager *merge,
                   GtkWidget    *widget,
                   gpointer      user_data)

The add_widget signal is emitted for each generated menubar and toolbar. It is not emitted for generated popup menus, which can be obtained by `gtk_ui_manager_get_widget()`.

#### Parameters

merge | a GtkUIManager |
widget | the added widget |
user_data | user data set when the signal handler was connected. |

Flags: No Recursion

Since: 2.4

### The `“connect-proxy”` signal

    void
    user_function (GtkUIManager *uimanager,
                   GtkAction    *action,
                   GtkWidget    *proxy,
                   gpointer      user_data)

The connect_proxy signal is emitted after connecting a proxy to an action in the group.

This is intended for simple customizations for which a custom action class would be too clumsy, e.g. showing tooltips for menuitems in the statusbar.

#### Parameters

uimanager | the ui manager |
action | the action |
proxy | the proxy |
user_data | user data set when the signal handler was connected. |

Flags: No Recursion

Since: 2.4

### The `“disconnect-proxy”` signal

    void
    user_function (GtkUIManager *uimanager,
                   GtkAction    *action,
                   GtkWidget    *proxy,
                   gpointer      user_data)

The disconnect_proxy signal is emitted after disconnecting a proxy from an action in the group.

#### Parameters

uimanager | the ui manager |
action | the action |
proxy | the proxy |
user_data | user data set when the signal handler was connected. |

Flags: No Recursion

Since: 2.4

### The `“post-activate”` signal

    void
    user_function (GtkUIManager *uimanager,
                   GtkAction    *action,
                   gpointer      user_data)

The post_activate signal is emitted just after the `action` is activated.

This is intended for applications to get notification just after any action is activated.

#### Parameters

uimanager | the ui manager |
action | the action |
user_data | user data set when the signal handler was connected. |

Flags: No Recursion

Since: 2.4

### The `“pre-activate”` signal

    void
    user_function (GtkUIManager *uimanager,
                   GtkAction    *action,
                   gpointer      user_data)

The pre_activate signal is emitted just before the `action` is activated.

This is intended for applications to get notification just before any action is activated.

#### Parameters

uimanager | the ui manager |
action | the action |
user_data | user data set when the signal handler was connected. |

Flags: No Recursion

Since: 2.4

## See Also

GtkBuilder